Fix make-array transforms.
[sbcl.git] / make.sh
diff --git a/make.sh b/make.sh
index 58907b8..a82b3c2 100755 (executable)
--- a/make.sh
+++ b/make.sh
@@ -1,6 +1,10 @@
 #!/bin/sh
 set -e
 
+LANG=C
+LC_ALL=C
+export LANG LC_ALL
+
 # "When we build software, it's a good idea to have a reliable method
 # for getting an executable from it. We want any two reconstructions
 # starting from the same source to end up in the same result. That's
@@ -16,61 +20,19 @@ set -e
 # provided with absolutely no warranty. See the COPYING and CREDITS
 # files for more information.
 
-# The value of SBCL_XC_HOST should be a command to invoke the
-# cross-compilation Lisp system in such a way that it reads commands
-# from standard input, and terminates when it reaches end of file on
-# standard input. Some suitable values are:
-#   "sbcl"        to use an existing SBCL binary as a cross-compilation host
-#   "sbcl --sysinit /dev/null --userinit /dev/null"
-#                 to use an existing SBCL binary as a cross-compilation host
-#                 even though you have stuff in your initialization files
-#                 which makes it behave in such a non-standard way that
-#                 it keeps the build from working
-#   "sbcl --disable-debugger"
-#                 to use an existing SBCL binary as a cross-compilation host
-#                 and tell it to handle errors as best it can by itself
-#                 (probably by dying with an error code) instead of waiting
-#                 endlessly for a programmer to help it out with input
-#                 on *DEBUG-IO*
-#   "lisp -batch" to use an existing CMU CL binary as a cross-compilation host
-#   "lisp -noinit -batch"
-#                 to use an existing CMU CL binary as a cross-compilation host
-#                 when you have weird things in your .cmucl-init file
-#   "openmcl --batch"
-#                 to use an OpenMCL binary as a cross-compilation host
-#   "clisp"
-#                 to use a CLISP binary as a cross-compilation host
-#
-# FIXME: Make a more sophisticated command line parser, probably
-# accepting "sh make.sh --xc-host foolisp" instead of the
-# the present "sh make.sh foolisp".
-# FIXME: Tweak this script, and the rest of the system, to support
-# a second bootstrapping pass in which the cross-compilation host is
-# known to be SBCL itself, so that the cross-compiler can do some
-# optimizations (especially specializable arrays) that it doesn't
-# know how to implement how in a portable way. (Or maybe that wouldn't
-# require a second pass, just testing at build-the-cross-compiler time
-# whether the cross-compilation host returns suitable values from
-# UPGRADED-ARRAY-ELEMENT-TYPE?)
+# If you're cross-compiling, make-config.sh should "do the right
+# thing" when run on the target machine, with the minor caveat that
+# any --xc-host parameter should be suitable for the host machine
+# instead of the target.
+sh make-config.sh "$@" || exit $?
 
-LANG=C
-LC_ALL=C
-export LANG LC_ALL
+. output/prefix.def
+. output/build-config
 
 build_started=`date`
-echo "//starting build: $build_started"
-
-SBCL_XC_HOST="${1:-sbcl --disable-debugger --userinit /dev/null --sysinit /dev/null}"
-export SBCL_XC_HOST
-echo //SBCL_XC_HOST=\"$SBCL_XC_HOST\"
-
-. ./find-gnumake.sh
-find_gnumake
-
-# If you're cross-compiling, you should probably just walk through the
-# make-config.sh script by hand doing the right thing on both the host
-# and target machines.
-sh make-config.sh
+echo "//Starting build: $build_started"
+# Apparently option parsing succeeded. Print out the results.
+echo "//Options: --prefix='$SBCL_PREFIX' --xc-host='$SBCL_XC_HOST'"
 
 # Enforce the source policy for no bogus whitespace
 tools-for-build/canonicalize-whitespace
@@ -109,7 +71,7 @@ time sh make-target-2.sh
 time sh make-target-contrib.sh
 
 NCONTRIBS=`find contrib -name Makefile -print | wc -l`
-NPASSED=`find contrib -name test-passed -print | wc -l`
+NPASSED=`find obj/asdf-cache -name test-passed.test-report -print | wc -l`
 echo
 echo "The build seems to have finished successfully, including $NPASSED (out of $NCONTRIBS)"
 echo "contributed modules. If you would like to run more extensive tests on"
@@ -129,6 +91,23 @@ echo "To install SBCL (more information in INSTALL):"
 echo
 echo "  sh install.sh"
 
+# This is probably the best place to ensure people will see this.
+if test -n "$legacy_xc_spec"
+then
+    echo <<EOF
+******************************************************************************
+**
+**  Old-style XC-host specification detected: '$SBCL_XC_HOST'
+**
+**  Since 1.0.41.45 SBCL expects the XC-host to be specified using
+**  the --xc-host='myhost' command line option, not with a positional
+**  argument. The legacy style still works, but will not be supported
+**  indefinitely. Please update your build procedure.
+**
+******************************************************************************
+EOF
+fi
+
 build_finished=`date`
 echo
 echo "//build started:  $build_started"